# $Id: mantis.spec,v 1.9 2006/10/20 23:56:20 giallu Exp $

%global pkgdir		%_datadir/%name
%global cfgdir		%_sysconfdir/%name
%global httpconfdir	%_sysconfdir/httpd/conf.d

%{!?release_func:%global release_func() %1%{?dist}}

Summary:	Web-based bugtracking system
Name:		mantis
Version:	0.19.4
Release:	%release_func 2
License:	GPL
Group:		Applications/Internet
URL:		http://mantisbt.sourceforge.net/
BuildArch:	noarch
Source0:	http://download.sourceforge.net/sourceforge/mantisbt/%name-%version%{?alpha}.tar.gz
Patch0:		mantis-0.19.2-iis.patch
Patch1:		mantis-0.19.2-noexamplecom.patch
Patch2:		mantis-0.19.2-noadmin.patch
# unreleased patches from CVS. Could be removed after an eventual 0.19.5 release
Patch3:		mantis-0.19.5-unreleased.patch
BuildRoot:	%_tmppath/%name-%version-%release-buildroot
BuildRequires:	diffutils
Requires:	php
Requires:	mantis-config


%package config-httpd
Summary:	Mantis configuration for Apache httpd
Group:		Applications/Internet
Source10:	mantis-httpd.conf
Provides:	mantis-config = httpd
Requires:	mantis = %version-%release
Requires:	%httpconfdir
Requires:	mod_ssl
Requires(post):		httpd
Requires(postun):	httpd


%description
Mantis is a web-based bugtracking system. It is in active development
and is considered beta.

It is written in the PHP scripting language and requires the MySQL
database and a webserver. Mantis has been installed on Windows, MacOS,
OS/2, and a variety of Unix operating systems. Any web browser should
be able to function as a client. It is released under the terms of the
GNU General Public License (GPL).

%description config-httpd
Mantis is a web-based bugtracking system. It is in active development
and is considered beta.

This package contains configuration-files for Apache httpd 2.


%prep
%setup -q
%patch0 -p1 -b .iis
%patch1 -p1 -b .noexamplecom
%patch2 -p1 -b .noadmin
%patch3 -p0 -b .unreleased

chmod -x *.php sql/*
rm -rf packages

sed -e '$s!CONCAT.*!md5(random()*random())||md5(now()));!;
	s! COMMENT=.*;!;!;
	s! UNIQUE KEY [^ ]* ! UNIQUE !g;
	s!^\( *\)KEY .*[^,]\(,\?\)$!\1CHECK (TRUE)\2!;
	s! tinyint! int!;
	s! unsigned ! !g;
	s! longblob ! text !g;
	s! datetime ! timestamp with time zone !g;
	s!TYPE=MyISAM!WITHOUT OIDS!g;
	s!^#!-- !;
	s! int.*auto_increment! SERIAL!;
	s! int([0-9]*) ! int !' sql/db_generate.sql >sql/db_generate-psql.sql


%install
rm -rf "$RPM_BUILD_ROOT"

%__install -d -m755 $RPM_BUILD_ROOT%pkgdir
%__install -d -m750 $RPM_BUILD_ROOT%cfgdir

tar cf - . | tar xf - -C $RPM_BUILD_ROOT%pkgdir


find $RPM_BUILD_ROOT \( \
	-name '*.noexamplecom' -o -name '*.iis' -o -name '*.noadmin' -o -name '*.#.*' -o \
	-name '.cvsignore' \
	\) -print0 | xargs -0 rm -f

## Do not rename; the *existence* of this file will be checked to
## determine if mantis is offline
mv $RPM_BUILD_ROOT%pkgdir/mantis_offline.php.sample $RPM_BUILD_ROOT%cfgdir/
mv $RPM_BUILD_ROOT%pkgdir/config_inc.php.sample     $RPM_BUILD_ROOT%cfgdir/config_inc.php

for i in $(find $RPM_BUILD_ROOT -type f -regex '.*\.\(php\|txt\|gif\|png\|css\|htm\|dtd\|xsl\|sql\|js\|bak\|xml\)$' -perm +0111); do
	case $i in
		(*.php)
			if ! sed '1p;d' "$i" | grep -q '^#!'; then
			   chmod a-x "$i"
			elif sed '1p;d' "$i" | grep -q '/usr/local/bin/php'; then
			   sed -i -e '1s!/usr/local/bin/php!/usr/bin/php!' "$i"
			fi
			;;
		(*.bak)		rm -f "$i";;
		(*)		chmod a-x "$i";;
	esac
done

chmod -x $RPM_BUILD_ROOT%pkgdir/{doc/*,core/phpmailer/{README,LICENSE}}

ln -s %cfgdir/config_inc.php	   $RPM_BUILD_ROOT%pkgdir/config_inc.php
ln -s %cfgdir/mantis_offline.php $RPM_BUILD_ROOT%pkgdir/mantis_offline.php


## The httpd config-files
function subst() {
	f=$RPM_BUILD_ROOT$1
	sed -e 's!/usr/share/mantis!%pkgdir!g' "$f" >"$f".tmp
	cmp -s "$f" "$f.tmp" || cat "$f.tmp" >"$f"
	rm -f "$f.tmp"
}

%__install -d $RPM_BUILD_ROOT%httpconfdir
%__install -p -m644 %SOURCE10 $RPM_BUILD_ROOT%httpconfdir/mantis.conf
subst %httpconfdir/mantis.conf


%clean
rm -rf "$RPM_BUILD_ROOT"


%post config-httpd
! /sbin/pidof httpd &>/dev/null || /usr/sbin/apachectl graceful || :

%postun config-httpd
! /sbin/pidof httpd &>/dev/null || /usr/sbin/apachectl graceful || :


%files
%defattr(-,root,root,-)
%doc sql
%pkgdir
%exclude %pkgdir/sql
%attr(-,root,apache) %dir %cfgdir
%attr(0640,root,apache) %config(noreplace) %cfgdir/*


%files config-httpd
%defattr(-,root,root,-)
%config(noreplace) %httpconfdir/*


%changelog
* Sat Oct 21 2006 Gianluca Sforna <giallu gmail com> 0.19.4-2
- add unreleased security patches from CVS

* Fri Dec 23 2005 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0.19.4-1
- SECURITY: release 0.19.4
  * File Upload Vulnerability (TKADV2005-11-002) (thraxisp)
  * Injection Vulnerabilities in Filters (TKADV2005-11-002)
  * SQL Injection in manage user page (TKADV2005-11-002)
  * HTTP Header CRLF Injection (TKADV2005-11-002) (vboctor)
  * Port XSS Vulnerability in filters (TKADV2005-11-002) (thraxisp)
- removed x-permission from most files

* Thu Oct 27 2005 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0.19.3-1
- updated to 0.19.3 (SECURITY)
- minor spec file cleanups

* Thu May 19 2005 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0.19.2-2
- use %%dist instead of %%disttag

* Mon Mar  7 2005 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0.19.2-1
- updated to 0.19.2
- rediffed patches
- removed dependency on php-mysql as it supports PostgreSQL also
- added inline-hack to generate a PostgreSQL database creation script

* Thu May 27 2004 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:0.18.3-0.fdr.2
- ship doc/ in the program-directory instead of copying it into %%docdir
- modified shipped httpd configuration to disable admin/ directory
  explicitly and added some documentation there
- added noadmin patch to disable warning about existing admin/ directory;
  since this directory is disabled by httpd configuration
- lower restrictions on the required 'mantis-config' subpackage; use
  descriptive names as version instead of EVR
- restart 'httpd' after the upgrade
- preserve timestamps of the configuration files to avoid creation of
  .rpmnew files on every update

* Tue May 25 2004 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:0.18.3-0.fdr.0.1
- updated to 0.18.2
- rediffed the patches

* Fri Aug 15 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.18.0-0.fdr.0.2.a4
- use generic download-address for Source0

* Thu Jun 19 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.18.0-0.fdr.0.1.a4
- applied the Fedora naming standard

* Thu Jun 19 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.18.0-0.fdr.0.a4.2
- Initial build.
